﻿;
; draw a sheared image
;
EnableExplicit

XIncludeFile "gDrawing.pbi"

Procedure MirrorImage(original,x,y)
    Protected copy, w, h
    copy = CreateImage(#PB_Any,ImageWidth(original),ImageHeight(original),24)
    ;copy = CopyImage(original,#PB_Any)
    If copy
        w = ImageWidth(original)
        h = ImageHeight(original)
        If gStartDrawing( ImageOutput(copy) )
            gSetPenImage( ImageID(original) ,#WrapModeTileFlipXY)
            If x : gSetPenOrigin(0,h) : EndIf
            If y : gSetPenOrigin(w,0) : EndIf
            gBox(0,0,w,h)
            gStopDrawing()
        EndIf
    EndIf
    ProcedureReturn copy
EndProcedure

Procedure DrawShearedImage(img,x.f,y.f,ShearX.f,ShearY.f)
    gStartTransform()
        gShearAt(x,y,ShearX,ShearY)
        gDrawImage(img,x,y,ImageWidth(img),ImageHeight(img)*0.7)
    gStopTransform()
EndProcedure

Define pbLogo, pbLogoMirror, img

pbLogo = LoadImage(#PB_Any,#PB_Compiler_Home+"Examples\Sources\Data\PureBasicLogo.bmp")
If Not pbLogo : MessageRequester("ERROR","Unable to load PureBasic logo!") : End : EndIf


If gInit()

    pbLogoMirror = MirrorImage(pbLogo,1,0)
    
    img = CreateImage(#PB_Any,800,600)
    If gStartDrawing( ImageOutput(img) )
        DrawImage(ImageID(pblogo),100,100)
        DrawShearedImage(pbLogoMirror,100,100+ImageHeight(pbLogo),0.8,0)
        gStopDrawing()
    EndIf

    OpenWindow(#PB_Any,0,0,800,600,"gDrawing gShear",#PB_Window_SystemMenu|#PB_Window_ScreenCentered)
    ImageGadget(#PB_Any,0,0,800,600,ImageID( img ),#PB_Image_Border ) ; normal
    Repeat : Until WaitWindowEvent()=#PB_Event_CloseWindow
    gEnd()
EndIf
; IDE Options = PureBasic 4.60 (Windows - x64)
; EnableUnicode
; EnableXP
; Executable = example03.exe
; CPU = 5
; DisableDebugger
