﻿;
; gCurve() & gClosedCurve()
;
XIncludeFile "gDrawing.pbi"

Procedure Draw()
    tension.f = 0
    gSetPen($AAFFFFFF,2)
    gSetFont("Arial",18)
    For i = 0 To 16
        gDrawingMode( #PB_2DDrawing_Default  ) : gCurve      (10,200,50, 50,90,200,tension)
        gDrawingMode( #PB_2DDrawing_Outlined ) : gCurve      (10,200,50, 50,90,200,tension,$FF000000)
        gDrawingMode( #PB_2DDrawing_Default  ) : gClosedCurve(10,400,50,250,90,400,tension)
        gDrawingMode( #PB_2DDrawing_Outlined ) : gClosedCurve(10,400,50,250,90,400,tension,$FF000000)
        gDrawingMode( #PB_2DDrawing_Default  )
        gDrawText(30,205,StrF(tension,2),$FFFFFFFF)
        tension + 0.4
        gSetOrigin(115,0)
    Next i
EndProcedure

If gInit()
    mainWin = OpenWindow(#PB_Any,0,0,800,600,"gDrawing: gCurve() & gClosedCurve()",#PB_Window_SystemMenu|#PB_Window_ScreenCentered)
    img = CreateImage(#PB_Any,2000,650,24)
    If gStartDrawing( ImageOutput(img) )
        gClear( RGBA($AA,$AA,$AA,$FF) )
        Draw()
        gStopDrawing()
    EndIf
    ScrollAreaGadget(#PB_Any,0,0,800,600,2000,650)
        imgWin  = ImageGadget(#PB_Any,0,0,2000,650,ImageID(img))
    CloseGadgetList()
    Repeat : Until WaitWindowEvent()=#PB_Event_CloseWindow
    gEnd()
EndIf

; IDE Options = PureBasic 4.60 (Windows - x64)
; EnableUnicode
; EnableXP
; Executable = example05.exe
; CPU = 5
; DisableDebugger