﻿;
; gClipPath() demo
;
EnableExplicit

XIncludeFile "gDrawing.pbi"

Procedure Draw(image)
    Protected i,j

    If gStartDrawing( ImageOutput(image) )
        gClear(RGBA($80,$80,$80,$FF))

        gDrawingMode(#PB_2DDrawing_Path)

            For i = 0 To 6
                gEllipse(i*130,i*100,200,70)                        ; add some ellipses
            Next i
            gRoundBox(500,100,200,50,10,10)                         ; add 2 round boxes to the path
            gRoundBox(100,450,200,50,10,10)

        gDrawingMode(#PB_2DDrawing_Default)

        gClipPath()                                                 ; set clipping to the path

        For i = 0 To 600 Step 8                                     ; draw many lines to the clipped area
            gLineXY( 0 , 0 ,800,i,$FF0000FF)
            gLineXY(800,600, 0 ,i,$FFFF0000)
        Next i
        
        gResetClip()                                                ; reset clipping
        gLineXY(0,0,800,600)                                        ; and draw another line
        
        gDrawingMode(#PB_2DDrawing_Outlined)
        ;gDrawPath()
        
        gStopDrawing()
    EndIf
EndProcedure

Define img

If gInit()

    img = CreateImage(#PB_Any,800,600)
    Draw(img)

    OpenWindow(#PB_Any,0,0,800,600,"gDrawing: gClipPath",#PB_Window_SystemMenu|#PB_Window_ScreenCentered)
    ImageGadget(#PB_Any,0,0,800,600,ImageID( img ))
    Repeat : Until WaitWindowEvent()=#PB_Event_CloseWindow

    gEnd()
EndIf
; IDE Options = PureBasic 4.60 (Windows - x64)
; EnableUnicode
; EnableXP
; Executable = example15.exe
; CPU = 5
; DisableDebugger
